<!DOCTYPE style-sheet PUBLIC "-//James Clark//DTD DSSSL Style Sheet//EN">

<style-specification id="iso-10179-procedures">

;; Refer to this as 
;; PUBLIC "ISO/IEC 10179:1996//Procedures::Reference Implementations"

;; New procedures can be added as necessary; only add here if they are
;; sample implementations from the text of the DSSSL Standard.

;; (node-list-filter) from ISO/IEC 10179
(define (node-list-filter proc
			  nl)
  (node-list-reduce nl
		    (lambda (result snl)
		      (if (proc snl)
			  (node-list snl
				     result)
			  result))
		    (empty-node-list)))

;; (node-list-reduce) from ISO/IEC 10179
(define (node-list-reduce nl
			  combine
			  init)
  (if (node-list-empty? nl)
      init
      (node-list-reduce (node-list-rest nl)
			combine
			(combine init
				 (node-list-first nl)))))

